Index: src/mlx/gui/delaycodes.py
===================================================================
--- src/mlx/gui/delaycodes.py	(revision 999)
+++ src/mlx/gui/delaycodes.py	(revision 840)
@@ -3,5 +3,5 @@
 #------------------------------------------------------------------------------
 
-from .dcdata import CAPTION, DELAYCODE, getTable
+from dcdata import CAPTION, DELAYCODE, getTable
 
 from mlx.gui.common import *
@@ -11,124 +11,181 @@
 #------------------------------------------------------------------------------
 
-class Viewport(Gtk.Viewport):
-    """Viewport implementation that alleviates the problem with improper
-    resizing by the VBox."""
-    def __init__(self):
-        """Construct the viewport."""
-        Gtk.Viewport.__init__(self)
-        self._recursive = False
-        self._vboxHeight = None
-
-    def setVBOXHeight(self, vboxHeight):
-        """Set the height of the VBox which will be used to calculate the
-        viewport's height."""
-        self._vboxHeight = vboxHeight
-
-    def do_size_allocate(self, allocation):
-        """Called when the viewport's size is allocated.
-
-        The height in the allocation object is modified so that it is only
-        so high to fit into the VBox."""
-        if self._vboxHeight is not None:
-            allocation.y += 1
-            allocation.height = self._vboxHeight - allocation.y
+if pygobject:
+
+#------------------------------------------------------------------------------
+
+    class Viewport(gtk.Viewport):
+        """Viewport implementation that alleviates the problem with improper
+        resizing by the VBox."""
+        def __init__(self):
+            """Construct the viewport."""
+            gtk.Viewport.__init__(self)
+            self._recursive = False
             self._vboxHeight = None
-        Gtk.Viewport.do_size_allocate(self, allocation)
-
-class DelayCodeTableBase(Gtk.VBox, Gtk.Scrollable):
-    """PyGObject-specific base class for the delay code table."""
-    __gproperties__ = {
-        "vscroll-policy" : ( Gtk.ScrollablePolicy,
-                             "vscroll-policy",
-                             "The vertical scrolling policy",
-                             Gtk.ScrollablePolicy.MINIMUM,
-                             GObject.PARAM_READWRITE ),
-        "vadjustment" : ( Gtk.Adjustment,
-                          "vadjustment",
-                          "The vertical adjustment",
-                          GObject.PARAM_READWRITE ),
-        "hscroll-policy" : ( Gtk.ScrollablePolicy,
-                             "hscroll-policy",
-                             "The horizontal scrolling policy",
-                             Gtk.ScrollablePolicy.MINIMUM,
-                             GObject.PARAM_READWRITE ),
-        "hadjustment" : ( Gtk.Adjustment,
-                          "hadjustment",
-                          "The horizontal adjustment",
-                          GObject.PARAM_READWRITE )  }
-
-
-    @staticmethod
-    def _createViewport():
-        """Create an instance of the viewport class used by this base class."""
-        return Viewport()
-
-    def __init__(self):
-        """Construct the delay code table."""
-        super(DelayCodeTableBase, self).__init__()
-
-    def do_size_allocate(self, allocation):
-        """Allocate the size for the table and its children.
-
-        This sets up the VBox height in the viewport and then calls the
-        do_size_allocate() function of VBox()."""
-        self._viewport.setVBOXHeight(allocation.height)
-        Gtk.VBox.do_size_allocate(self, allocation)
-        self.allocate_column_sizes(allocation)
-
-    def do_get_property(self, prop):
-        """Get the value of one of the properties defined above.
-
-        The request is forwarded to the viewport."""
-        if prop.name=="vscroll-policy":
-            return self._viewport.get_vscroll_policy()
-        elif prop.name=="hscroll-policy":
-            return self._viewport.get_hscroll_policy()
-        elif prop.name=="vadjustment":
-            return self._viewport.get_vadjustment()
-        elif prop.name=="hadjustment":
-            return self._viewport.get_hadjustment()
-        else:
-            raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_get_property" %
-                                 (prop.name,))
-
-    def do_set_property(self, prop, value):
-        """Set the value of the adjustment properties defined above.
-
-        The adjustments are forwarded to the viewport."""
-        if prop.name=="vadjustment":
-            self._viewport.set_vadjustment(value)
-        elif prop.name=="hadjustment":
-            self._viewport.set_hadjustment(value)
-            self._treeView.set_hadjustment(value)
-        else:
-            raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_set_property" %
-                                 (prop.name,))
-
-    def setStyle(self):
-        """Set the style of the event box from the treeview."""
-
-class Alignment(Gtk.Alignment):
-    """An alignment that remembers the width it was given."""
-    def __init__(self, xalign = 0.0, yalign=0.0,
-                 xscale = 0.0, yscale = 0.0 ):
-        """Construct the alignment."""
-        super(Alignment, self).__init__(xalign = xalign, yalign = yalign,
-                                        xscale = xscale, yscale = yscale)
-        self.allocatedWidth = 0
-
-    def do_size_allocate(self, allocation):
-        """Called with the new size allocation."""
-        self.allocatedWidth = allocation.width
-        Gtk.Alignment.do_size_allocate(self, allocation)
-
-class TreeView(Gtk.TreeView):
-    def do_size_allocate(self, allocation):
-        allocation.height += 1
-        Gtk.TreeView.do_size_allocate(self, allocation)
-
-#------------------------------------------------------------------------------
-
-class CheckButton(Gtk.CheckButton):
+
+        def setVBOXHeight(self, vboxHeight):
+            """Set the height of the VBox which will be used to calculate the
+            viewport's height."""
+            self._vboxHeight = vboxHeight
+
+        def do_size_allocate(self, allocation):
+            """Called when the viewport's size is allocated.
+
+            The height in the allocation object is modified so that it is only
+            so high to fit into the VBox."""
+            if self._vboxHeight is not None:
+                allocation.height = self._vboxHeight - allocation.y
+                self._vboxHeight = None
+            gtk.Viewport.do_size_allocate(self, allocation)
+
+    class DelayCodeTableBase(gtk.VBox, gtk.Scrollable):
+        """PyGObject-specific base class for the delay code table."""
+        __gproperties__ = {
+            "vscroll-policy" : ( gtk.ScrollablePolicy,
+                                 "vscroll-policy",
+                                 "The vertical scrolling policy",
+                                 gtk.ScrollablePolicy.MINIMUM,
+                                 gobject.PARAM_READWRITE ),
+            "vadjustment" : ( gtk.Adjustment,
+                              "vadjustment",
+                              "The vertical adjustment",
+                              gobject.PARAM_READWRITE ),
+            "hscroll-policy" : ( gtk.ScrollablePolicy,
+                                 "hscroll-policy",
+                                 "The horizontal scrolling policy",
+                                 gtk.ScrollablePolicy.MINIMUM,
+                                 gobject.PARAM_READWRITE ),
+            "hadjustment" : ( gtk.Adjustment,
+                              "hadjustment",
+                              "The horizontal adjustment",
+                              gobject.PARAM_READWRITE )  }
+
+
+        @staticmethod
+        def _createViewport():
+            """Create an instance of the viewport class used by this base class."""
+            return Viewport()
+
+        def __init__(self):
+            """Construct the delay code table."""
+            super(DelayCodeTableBase, self).__init__()
+
+        def do_size_allocate(self, allocation):
+            """Allocate the size for the table and its children.
+
+            This sets up the VBox height in the viewport and then calls the
+            do_size_allocate() function of VBox()."""
+            self._viewport.setVBOXHeight(allocation.height)
+            gtk.VBox.do_size_allocate(self, allocation)
+            self.allocate_column_sizes(allocation)
+
+        def do_get_property(self, prop):
+            """Get the value of one of the properties defined above.
+
+            The request is forwarded to the viewport."""
+            if prop.name=="vscroll-policy":
+                return self._viewport.get_vscroll_policy()
+            elif prop.name=="hscroll-policy":
+                return self._viewport.get_hscroll_policy()
+            elif prop.name=="vadjustment":
+                return self._viewport.get_vadjustment()
+            elif prop.name=="hadjustment":
+                return self._viewport.get_hadjustment()
+            else:
+                raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_get_property" %
+                                     (prop.name,))
+
+        def do_set_property(self, prop, value):
+            """Set the value of the adjustment properties defined above.
+
+            The adjustments are forwarded to the viewport."""
+            if prop.name=="vadjustment":
+                self._viewport.set_vadjustment(value)
+            elif prop.name=="hadjustment":
+                self._viewport.set_hadjustment(value)
+                self._treeView.set_hadjustment(value)
+            else:
+                raise AttributeError("mlx.gui.delaycodes.DelayCodeTableBase: property %s is not handled in do_set_property" %
+                                     (prop.name,))
+
+        def setStyle(self):
+            """Set the style of the event box from the treeview."""
+
+    class Alignment(gtk.Alignment):
+        """An alignment that remembers the width it was given."""
+        def __init__(self, xalign = 0.0, yalign=0.0,
+                     xscale = 0.0, yscale = 0.0 ):
+            """Construct the alignment."""
+            super(Alignment, self).__init__(xalign = xalign, yalign = yalign,
+                                            xscale = xscale, yscale = yscale)
+            self.allocatedWidth = 0
+
+        def do_size_allocate(self, allocation):
+            """Called with the new size allocation."""
+            self.allocatedWidth = allocation.width
+            gtk.Alignment.do_size_allocate(self, allocation)
+
+#------------------------------------------------------------------------------
+
+else: # pygobject
+
+#------------------------------------------------------------------------------
+
+    class DelayCodeTableBase (gtk.VBox):
+        """Base class of the delay code table for PyGtk."""
+
+        __gsignals__ = {
+            "set-scroll-adjustments": (
+                gobject.SIGNAL_RUN_LAST,
+                gobject.TYPE_NONE, (gtk.Adjustment, gtk.Adjustment))
+                }
+
+        @staticmethod
+        def _createViewport():
+            """Create an instance of the viewport class used by this base class."""
+            return gtk.Viewport()
+
+        def __init__(self):
+            """Construct the base class."""
+            super(DelayCodeTableBase, self).__init__()
+            self.set_set_scroll_adjustments_signal("set-scroll-adjustments")
+            self.connect("size-allocate", self._do_size_allocate)
+
+        def do_set_scroll_adjustments(self, hAdjustment, vAdjustment):
+            """Set the adjustments on the viewport."""
+            self._viewport.set_hadjustment(hAdjustment)
+            self._viewport.set_vadjustment(vAdjustment)
+            self._treeView.set_hadjustment(hAdjustment)
+
+        def _do_size_allocate(self, widget, allocation):
+            """Handler of the size-allocate signal.
+
+            Calls allocate_column_sizes()."""
+            self.allocate_column_sizes(allocation)
+
+        def setStyle(self):
+            """Set the style of the event box from the treeview."""
+            if self._treeView is not None:
+                style = self._treeView.rc_get_style()
+                self._eventBox.modify_bg(0, style.bg[2])
+                self._eventBox.modify_fg(0, style.fg[2])
+
+    class Alignment(gtk.Alignment):
+        """An alignment that remembers the width it was given."""
+        def __init__(self, xalign = 0.0, yalign=0.0,
+                     xscale = 0.0, yscale = 0.0 ):
+            """Construct the alignment."""
+            super(Alignment, self).__init__(xalign = xalign, yalign = yalign,
+                                            xscale = xscale, yscale = yscale)
+            self.allocatedWidth = 0
+            self.connect("size-allocate", self._do_size_allocate)
+
+        def _do_size_allocate(self, widget, allocation):
+            """Called with the new size allocation."""
+            self.allocatedWidth = allocation.width
+
+#------------------------------------------------------------------------------
+
+class CheckButton(gtk.CheckButton):
     """A check button that contains a reference to a row in the delay code
     data table."""
@@ -184,5 +241,5 @@
         self._delayCodeData = None
 
-        self._treeView = TreeView(Gtk.ListStore(str, str))
+        self._treeView = gtk.TreeView(gtk.ListStore(str, str))
         self._treeView.set_rules_hint(True)
 
@@ -192,5 +249,5 @@
         self._checkButtons = []
 
-        self._eventBox = Gtk.EventBox()
+        self._eventBox = gtk.EventBox()
 
         self._table = None
@@ -198,5 +255,5 @@
         self._viewport = self._createViewport()
         self._viewport.add(self._eventBox)
-        self._viewport.set_shadow_type(Gtk.ShadowType.NONE)
+        self._viewport.set_shadow_type(SHADOW_NONE)
 
         self.pack_start(self._viewport, True, True, 0)
@@ -254,14 +311,14 @@
         numRows = len(rows)
 
-        column = Gtk.TreeViewColumn("", Gtk.CellRendererText())
-        column.set_sizing(Gtk.TreeViewColumnSizing.FIXED)
+        column = gtk.TreeViewColumn("", gtk.CellRendererText())
+        column.set_sizing(TREE_VIEW_COLUMN_FIXED)
         self._treeView.append_column(column)
 
         for header in headers:
-            column = Gtk.TreeViewColumn(header, Gtk.CellRendererText())
-            column.set_sizing(Gtk.TreeViewColumnSizing.FIXED)
+            column = gtk.TreeViewColumn(header, gtk.CellRendererText())
+            column.set_sizing(TREE_VIEW_COLUMN_FIXED)
             self._treeView.append_column(column)
 
-        self._table = Gtk.Table(numRows, numColumns)
+        self._table = gtk.Table(numRows, numColumns)
         self._table.set_homogeneous(False)
         self._table.set_col_spacings(16)
@@ -276,12 +333,12 @@
             (type, elements) = rows[i]
             if type==CAPTION:
-                alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.5,
+                alignment = gtk.Alignment(xalign = 0.0, yalign = 0.5,
                                           xscale = 1.0)
-                label = Gtk.Label("<b>" + elements + "</b>")
+                label = gtk.Label("<b>" + elements + "</b>")
                 label.set_use_markup(True)
                 label.set_alignment(0.0, 0.5)
                 alignment.add(label)
                 self._table.attach(alignment, 1, numColumns, i, i+1,
-                                   yoptions = Gtk.AttachOptions.FILL)
+                                   yoptions = FILL)
                 self._table.set_row_spacing(i, 8)
             elif type==DELAYCODE:
@@ -292,20 +349,18 @@
                 alignment.add(checkButton)
                 self._table.attach(alignment, 0, 1, i, i+1,
-                                   xoptions = Gtk.AttachOptions.FILL,
-                                   yoptions = Gtk.AttachOptions.FILL)
+                                   xoptions = FILL, yoptions = FILL)
                 if firstDelayCodeRow:
                     self._alignments.append(alignment)
 
                 for j in range(0, numColumns-1):
-                    label = Gtk.Label(elements[j])
+                    label = gtk.Label(elements[j])
                     label.set_alignment(0.0, 0.5)
                     alignment = Alignment(xalign = 0.5, yalign = 0.5,
                                           xscale = 1.0)
                     alignment.add(label)
-                    xoptions = Gtk.AttachOptions.FILL
-                    if j==(numColumns-2): xoptions |= Gtk.AttachOptions.EXPAND
+                    xoptions = FILL
+                    if j==(numColumns-2): xoptions |= EXPAND
                     self._table.attach(alignment, j+1, j+2, i, i+1,
-                                       xoptions = xoptions,
-                                       yoptions = Gtk.AttachOptions.FILL)
+                                       xoptions = xoptions, yoptions = FILL)
                     if firstDelayCodeRow:
                         self._alignments.append(alignment)
Index: src/mlx/gui/faultexplain.py
===================================================================
--- src/mlx/gui/faultexplain.py	(revision 999)
+++ src/mlx/gui/faultexplain.py	(revision 842)
@@ -19,5 +19,5 @@
 #-------------------------------------------------------------------------------
 
-class FaultFrame(Gtk.Frame):
+class FaultFrame(gtk.Frame):
     """A frame containing the information about a single fault.
 
@@ -26,18 +26,21 @@
     def __init__(self, faultText):
         """Construct the frame."""
-        Gtk.Frame.__init__(self)
+        gtk.Frame.__init__(self)
 
         self._faultText = faultText
 
-        vbox = Gtk.VBox()
-
-        self._fault = fault = Gtk.Label()
-        fault.set_xalign(0.0)
-        fault.set_justify(Gtk.Justification.LEFT)
-        fault.set_line_wrap(True)
+        vbox = gtk.VBox()
+
+        self._fault = fault = gtk.TextView()
+        fault.set_editable(False)
+        fault.set_can_focus(False)
+        fault.set_wrap_mode(WRAP_WORD)
+
+        buffer = fault.get_buffer()
+        self._faultTag  = buffer.create_tag("fault", weight=WEIGHT_BOLD)
 
         self.faultText = faultText
 
-        faultAlignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        faultAlignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                        xscale = 1.0, yscale = 0.0)
         faultAlignment.set_padding(padding_top = 0, padding_bottom = 0,
@@ -46,6 +49,6 @@
         vbox.pack_start(faultAlignment, True, True, 4)
 
-        self._explanation = explanation = Gtk.TextView()
-        explanation.set_wrap_mode(Gtk.WrapMode.WORD)
+        self._explanation = explanation = gtk.TextView()
+        explanation.set_wrap_mode(WRAP_WORD)
         explanation.set_accepts_tab(False)
         explanation.set_size_request(-1, 100)
@@ -59,7 +62,11 @@
         self.show_all()
 
-        styleContext = self.get_style_context()
-        color = styleContext.get_background_color(Gtk.StateFlags.NORMAL)
-        fault.override_background_color(0, color)
+        if pygobject:
+            styleContext = self.get_style_context()
+            color = styleContext.get_background_color(gtk.StateFlags.NORMAL)
+            fault.override_background_color(0, color)
+        else:
+            style = self.rc_get_style()
+            fault.modify_base(0, style.bg[0])
 
         self._hasExplanation = False
@@ -74,5 +81,9 @@
         """Update the text of the fault."""
         self._faultText = faultText
-        self._fault.set_markup("<b>" + faultText + "</b>")
+
+        buffer = self._fault.get_buffer()
+        buffer.set_text(faultText)
+        buffer.apply_tag(self._faultTag,
+                         buffer.get_start_iter(), buffer.get_end_iter())
 
     @property
@@ -114,10 +125,10 @@
 #-------------------------------------------------------------------------------
 
-GObject.signal_new("explanation-changed", FaultFrame, GObject.SIGNAL_RUN_FIRST,
+gobject.signal_new("explanation-changed", FaultFrame, gobject.SIGNAL_RUN_FIRST,
                    None, (bool,))
 
 #-------------------------------------------------------------------------------
 
-class FaultExplainWidget(Gtk.Frame):
+class FaultExplainWidget(gtk.Frame):
     """The widget for the faults and their explanations."""
     @staticmethod
@@ -127,5 +138,5 @@
 
     def __init__(self, gui):
-        Gtk.Frame.__init__(self)
+        gtk.Frame.__init__(self)
 
         self._gui = gui
@@ -134,16 +145,16 @@
         label.set_use_underline(True)
 
-        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 1.0, yscale = 1.0)
         alignment.set_padding(padding_top = 4, padding_bottom = 4,
                               padding_left = 4, padding_right = 4)
 
-        self._outerBox = outerBox = Gtk.EventBox()
+        self._outerBox = outerBox = gtk.EventBox()
         outerBox.add(alignment)
 
-        self._innerBox = innerBox = Gtk.EventBox()
+        self._innerBox = innerBox = gtk.EventBox()
         alignment.add(self._innerBox)
 
-        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 1.0, yscale = 1.0)
         alignment.set_padding(padding_top = 0, padding_bottom = 0,
@@ -152,11 +163,11 @@
         innerBox.add(alignment)
 
-        scroller = Gtk.ScrolledWindow()
-        scroller.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
-        scroller.set_shadow_type(Gtk.ShadowType.NONE)
-
-        self._faults = Gtk.VBox()
+        scroller = gtk.ScrolledWindow()
+        scroller.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
+        scroller.set_shadow_type(SHADOW_NONE)
+
+        self._faults = gtk.VBox()
         self._faults.set_homogeneous(False)
-        scroller.add(self._faults)
+        scroller.add_with_viewport(self._faults)
 
         alignment.add(scroller)
@@ -189,5 +200,5 @@
         """Add a fault with the given ID and text."""
 
-        alignment = Gtk.Alignment(xalign = 0.0, yalign = 0.0,
+        alignment = gtk.Alignment(xalign = 0.0, yalign = 0.0,
                                       xscale = 1.0, yscale = 0.0)
         alignment.set_padding(padding_top = 2, padding_bottom = 2,
@@ -236,5 +247,5 @@
     def reset(self):
         """Reset the widget by removing all faults."""
-        for (alignment, faultFrame) in self._faultWidgets.values():
+        for (alignment, faultFrame) in self._faultWidgets.itervalues():
             self._faults.remove(alignment)
         self._faults.show_all()
@@ -281,20 +292,24 @@
         not."""
         allExplained = self._numExplanations >= self._numFaults
-        styleContext = self.get_style_context()
-        if allExplained:
-            outerColour = innerColour = Gdk.RGBA(red = 0.0, green=0.0,
-                                                 blue=0.0, alpha=0.0)
+        if pygobject:
+            styleContext = self.get_style_context()
+            if allExplained:
+                outerColour = innerColour = gdk.RGBA(red = 0.0, green=0.0,
+                                                     blue=0.0, alpha=0.0)
+            else:
+                outerColour = \
+                  styleContext.get_background_color(gtk.StateFlags.SELECTED)
+                innerColour = self._gui.backgroundColour
+
+            self._outerBox.override_background_color(gtk.StateFlags.NORMAL,
+                                                     outerColour)
+            self._innerBox.override_background_color(gtk.StateFlags.NORMAL,
+                                                     innerColour)
         else:
-            outerColour = \
-                styleContext.get_border_color(Gtk.StateFlags.DROP_ACTIVE)
-            innerColour = self._gui.backgroundColour
-
-        self._outerBox.override_background_color(Gtk.StateFlags.NORMAL,
-                                                 outerColour)
-        self._innerBox.override_background_color(Gtk.StateFlags.NORMAL,
-                                                 innerColour)
-
-#-------------------------------------------------------------------------------
-
-GObject.signal_new("explanations-changed", FaultExplainWidget,
-                   GObject.SIGNAL_RUN_FIRST, None, (bool,))
+            style = self.rc_get_style()
+            self._outerBox.modify_bg(0, style.bg[0 if allExplained else 3])
+
+#-------------------------------------------------------------------------------
+
+gobject.signal_new("explanations-changed", FaultExplainWidget,
+                   gobject.SIGNAL_RUN_FIRST, None, (bool,))
